use eframe::egui::{DragValue, Ui};

use crate::{application::Application, outline_geometry::OutlineGeometry};

pub fn show_gerber_actions(ui: &mut Ui, app: &mut Application) {
    if let Some((name, geo)) = app.gerbers.get(&app.selection) {
        ui.horizontal(|ui| {
            ui.add(
                DragValue::new(&mut app.variables.laser_line_width)
                    .range(0.1..=10.)
                    .suffix(geo.units),
            );

            if ui.button("Generate Isolation").clicked() {
                app.outlines.insert(
                    format!("{name}-Iso"),
                    OutlineGeometry::new(
                        &geo.outline_union,
                        app.variables.laser_line_width,
                        geo.units,
                        name,
                        geo.outline_union.bounds(),
                    ),
                );
            }
        });
    }
}
